//
//  ConnectionManager.h
//  MenuMenu
//
//  Created by Sławek Derwisz on 26.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "District.h"
#import "Restaurant.h"
#import "AppDelegate.h"
#import "LocationManager.h"

@interface ConnectionManager : NSObject{
    
}

@property (nonatomic, retain) NSMutableArray *restaurants;
@property (nonatomic, retain) NSMutableArray *districts;
@property (nonatomic, retain) NSMutableArray *cities;
@property (nonatomic, retain) NSData *restaurantsData;
@property (nonatomic, strong) NSArray *cachedRestaurants;
@property (nonatomic, retain) NSMutableData * receivedData;

+(ConnectionManager*)getInstance;

-(void)getDistrictsFromCountry: (NSString*) country;
-(void)getRestaurantsWithCityId: (NSString*)restId;
-(void)findNearbyWith: (float)lat andWith: (float)lon;
-(void)updateDistrictJSON;
@end
