//
//  LocationManager.h
//  MenuMenu
//
//  Created by Pawel Ferens on 3/1/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>
#import "AppDelegate.h"

@interface LocationManager : NSObject<CLLocationManagerDelegate>{
    float la;
    float lo;
}
@property float la;
@property float lo;
@property(nonatomic,retain)CLLocationManager*locationManager;
+(LocationManager *)getInstance;
-(void)getLocation;
-(double)calculateDistanceWithLatA:(float)latA
                          andLoA:(float)loA
                         andLatB:(float)latB
                          andLoB:(float)loB;
@end
