//
//  MainScrollViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 2/26/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "MainScrollViewController.h"

@interface MainScrollViewController ()

@end

@implementation MainScrollViewController{
    bool saveNewRestaurantJSON;
}

@synthesize restaurantList;
@synthesize scrollView;
@synthesize leftBar;
@synthesize rightBar;
@synthesize topBar;
@synthesize connectionManager;
@synthesize screenHeigth;
@synthesize screenWidth;
@synthesize thumbnails;
@synthesize leftColumnSize;
@synthesize rightColumnSize;
@synthesize scrollViewBackground;
@synthesize posx;
@synthesize orderOfDownloadedImages;
@synthesize districtId;
@synthesize cityLabel;
@synthesize singleScrollViewController;
@synthesize loadingView;
@synthesize spinner;
@synthesize locationManager;
@synthesize headersImg;
@synthesize menusImg;
@synthesize infoViewController;
@synthesize counter;
@synthesize counter2;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


-(BOOL)isPad
{
#ifdef UI_USER_INTERFACE_IDIOM
    return UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad;
#endif
    return NO;
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    locationManager=[LocationManager getInstance];
    infoViewController=[self.storyboard instantiateViewControllerWithIdentifier:@"info" ];
    restaurantsHorizontalView=[self.storyboard instantiateViewControllerWithIdentifier:@"restaurantsHorizontalView" ];
    screenHeigth=self.view.frame.size.height;
    screenWidth=self.view.frame.size.width;
    
//    spinner=[[UIActivityIndicatorView alloc]initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    
    
//    [spinner setFrame:CGRectMake(screenWidth/2-15, screenHeigth/2-15, 30, 30)];
    
//    [loadingView addSubview:spinner];
    
    
    
    [scrollViewBackground setImage:[UIImage imageNamed:@"bg.png"]];
    [scrollView setBackgroundColor:[UIColor clearColor]];
    [scrollView setDelegate:self];
    [leftBar setImage:[UIImage imageNamed:@"left_line.png"]];
    [rightBar setImage:[UIImage imageNamed:@"left_line.png"]];
    
    
  //  UIImage*backgroundImage=[UIImage imageNamed:@"menu_bg.png"];
   // [topBar setImage:backgroundImage];
    
    

    NSString *notificationName3 = @"goBack";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(goBack:)
     name:notificationName3
     object:nil];
    
    thumbnails=[[NSMutableArray alloc]init];
    
}

-(void)viewWillAppear:(BOOL)animated{
    
    [[UIDevice currentDevice] setOrientation:UIInterfaceOrientationPortrait];
    
    saveNewRestaurantJSON=NO;
}


-(void)viewDidAppear:(BOOL)animated
{
    [self appdelegate].rotateToLandScape=YES;
//    [spinner startAnimating];
    //  [[UIDevice currentDevice] setOrientation:UIInterfaceOrientationPortrait];
    if ([self appdelegate].isRestaurantsScreenLoaded) {
       // [loadingView setAlpha:0.0f];
        if([[self appdelegate]currentIndex]==0)
            [scrollView setContentOffset:CGPointMake(0, 0)];
        else
//            [scrollView setContentOffset:CGPointMake(0, [scrollView viewWithTag: [[self appdelegate]currentIndex]].frame.origin.y-70)];                                            //przewijanie
        
        NSLog(@"%d",[[self appdelegate]currentIndex]);
            
        if([self appdelegate].isFindNearby)
        {
            UIButton* bu=[headersImg objectAtIndex: [[self appdelegate]currentIndex]];
            [scrollView setContentOffset:CGPointMake(0,bu.frame.origin.y-70)];
        }
    }
    else
    {
      //  [loadingView setAlpha:1.0f];
        orderOfDownloadedImages=[[NSMutableArray alloc]init];
        connectionManager=[ConnectionManager getInstance];
//        if(![self appdelegate].isFindNearby)
//            [connectionManager getRestaurantsWithCityId:self.districtId];
//        else{
//            NSLog(@"Localization service status:");
//            if ([CLLocationManager locationServicesEnabled]) {
//                NSLog(@"Localization service enable.");
//                [locationManager getLocation];
//            }
//            else
//            {
//                NSLog(@"Localization service disable.");
//                [loadingView setAlpha:0];
//                UIAlertView*alert=[[UIAlertView alloc]initWithTitle:@""
//                                                            message:NSLocalizedString(@"TurnOnLocation", nil)
//                                                           delegate:self
//                                                  cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
//                                                  otherButtonTitles:nil  , nil];
//                
//                alert.tag=1;
//                [alert show];
//            }
//            
//        }
        [self loadScrollView:nil];
    }
}



-(void)prepareMenuViews{
    
    for(UIView *subview in [scrollView subviews]) {
        [subview removeFromSuperview];
    }
    
    headersImg = [[NSMutableArray alloc]init];
    menusImg = [[NSMutableArray alloc]init];
    
    int margin=10;
    int imageWidth=(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width-margin*3)/2;
    leftColumnSize=70;
    rightColumnSize=70;
    
    for (int i =0; i<connectionManager.restaurants.count; i++) {
        
        Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
        int columnSize;
        UIButton*t=nil;
        UIButton*to=nil;
        UIImage *emptyMenuImage=nil;
        //choose column;
        if (leftColumnSize<=rightColumnSize) {
            posx=margin+leftBar.frame.size.width;
            columnSize = leftColumnSize;
        }
        else{
            posx=2*margin+imageWidth+leftBar.frame.size.width;
            columnSize = rightColumnSize;
        }
        //load header image;
        if (temp.LOGOSize.height != 0) {
            float r=temp.LOGOSize.width/temp.LOGOSize.height;
            t = [[UIButton alloc]initWithFrame:CGRectMake(posx, columnSize, imageWidth, imageWidth/r)];
            [t setTag:i];
            [t addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
            //[t setBackgroundColor:[UIColor colorWithWhite:1 alpha:1]];
            columnSize=columnSize+imageWidth/r;
        }
        else{
            t = [[UIButton alloc]initWithFrame:CGRectMake(posx, columnSize, 0, 0)];
        }
        [headersImg addObject:t];
        
        //load menu image;
        if(![temp.menuImage isEqual:@""]){
            float ro;
            if (temp.MENUSize.height != 0) {
                ro=temp.MENUSize.width/temp.MENUSize.height;
            }
            else{
                emptyMenuImage = [UIImage imageNamed:@"menu_empty.jpg"];
                ro=emptyMenuImage.size.width/emptyMenuImage.size.height;
            }
            to= [[UIButton alloc]initWithFrame:CGRectMake(posx, columnSize, imageWidth, imageWidth/ro)];
            columnSize=columnSize+imageWidth/ro+margin;
            [to setTag:i];
            [to addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
            [menusImg addObject:to];
            //[to setBackgroundColor:[UIColor colorWithWhite:1 alpha:0.6f]];
        }
        
        if(to != nil){
            if(to != nil)
                [self.scrollView addSubview:t];
            
            [self.scrollView addSubview:to];
        }
        
        [scrollView setContentSize:CGSizeMake(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width, columnSize+250)];
        
        //refresh column size;
        if (leftColumnSize<=rightColumnSize) {
            leftColumnSize = columnSize;
        }
        else{
            rightColumnSize = columnSize;
        }
    }
}

-(void)scrollViewDidScroll:(UIScrollView *)scrollView2{
    if([self appdelegate].isFindNearby){
        for(int i=scrollView.subviews.count-1; i>0; i--){
            UIButton *vBtn = [scrollView.subviews objectAtIndex:i];
            
            int btnIndex = 0;
            if(vBtn.tag >= 2000)
                btnIndex = vBtn.tag-2000;
            else if(vBtn.tag >= 1000)
                btnIndex = vBtn.tag-1000;
            
            if(vBtn.frame.origin.y <= scrollView.contentOffset.y+100){
                
                Restaurant *rest=(Restaurant*)[connectionManager.restaurants objectAtIndex:btnIndex];
                LocationManager*man=[LocationManager getInstance];
                [man getLocation];
                rest.distance=[man calculateDistanceWithLatA:man.la
                                                      andLoA:man.lo
                                                     andLatB:[rest.lat floatValue]
                                                      andLoB:[rest.lng floatValue]];
                
                if(![cityLabel.text isEqualToString: [NSString stringWithFormat: @"%@ %.2f km", NSLocalizedString(@"Distance", nil), rest.distance]]
                   && ![cityLabel.text isEqualToString:[NSString stringWithFormat: @"%@ %.f m",NSLocalizedString(@"Distance", nil), rest.distance]]){
                    if(rest.distance >= 1000)
                        cityLabel.text = [NSString stringWithFormat: @"%@ %.2f km",NSLocalizedString(@"Distance", nil),rest.distance/1000];
                    else
                        cityLabel.text = [NSString stringWithFormat: @"%@ %.f m",NSLocalizedString(@"Distance", nil),rest.distance];
                    
                    NSLog(@"%f---- %f",scrollView.contentOffset.y, vBtn.frame.origin.y);
                    NSLog(@"name: %@ -- distance(m)=%f", rest.name, rest.distance);
                }
                break;
            }
        }
    }

}


-(void)loadScrollView:(NSNotification *)notification{
//    [loadingView setAlpha:0];
    if(connectionManager.restaurants.count >0){
        if([self appdelegate].isFindNearby){
            if(![self appdelegate].isRestaurantsScreenLoaded){
                [self prepareMenuViews];
                [self loadNearbyScrollView];
            }
            // [self appdelegate].isFindNearby = NO;
        }
        else{
            [self loadDistrictScrollView];
        }
    }
    else{
        //        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Empty", nil)
        //                                                        message:NSLocalizedString(@"NoRestaurant", nil)
        //                                                       delegate:nil
        //                                              cancelButtonTitle:NSLocalizedString(@"OkButton", nil)
        //                                              otherButtonTitles:nil];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:NSLocalizedString(@"Error", nil)
                                                        message:NSLocalizedString(@"NoRestaurant", nil)
                                                       delegate:nil
                                              cancelButtonTitle:@"OkButton"
                                              otherButtonTitles:nil];
        
        alert.tag = 0;
        alert.delegate = self;
        [alert show];
    }
}


-(void)loadNoContentMenus{
    
    int marigin=10;
    int imageWidth=(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width-marigin*3)/2;
    for(int i=0;i<[connectionManager.restaurants count];i++)
    {
        Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
        
        if ([connectionManager.restaurants count]>0
            && i < [connectionManager.restaurants count]
            && temp.menuImageDefault) {
            
            dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_LOW, 0), ^{
                
                [self getLogoImage:i];
                
                NSString*blobEnding=temp.menuImage;
                NSURL *url = [NSURL URLWithString:blobEnding];
                NSData *data = [NSData dataWithContentsOfURL:url];
                temp.downloadedMenuImage=[[UIImage alloc]initWithData:data];
                
                dispatch_async( dispatch_get_main_queue(), ^{
              
  
                    if ([connectionManager.restaurants count]>0 && i < [connectionManager.restaurants count]) {
                          [self.orderOfDownloadedImages addObject:[connectionManager.restaurants objectAtIndex:i]];
                        if (leftColumnSize<=rightColumnSize) {
                            posx=marigin+leftBar.frame.size.width;
                            Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
                            UIImage*p=temp.downloadedMainImage;
                            if (p!=nil) {
                                float r=p.size.width/p.size.height;
                                
                                UIButton*t= [[UIButton alloc]initWithFrame:CGRectMake(posx, leftColumnSize, imageWidth, imageWidth/r)];
                                [t setTag:i];
                                [t setBackgroundImage:p forState:UIControlStateNormal];
                                [t addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                leftColumnSize=leftColumnSize+imageWidth/r;
                                [self.scrollView addSubview:t];
                            }
                            
                            UIImage*po=temp.downloadedMenuImage;
                            if (po!=nil) {
                                
                                float ro=po.size.width/po.size.height;
                                
                                UIButton*to= [[UIButton alloc]initWithFrame:CGRectMake(posx, leftColumnSize, imageWidth, imageWidth/ro)];
                                
                                [to setBackgroundImage:po forState:UIControlStateNormal];
                                leftColumnSize=leftColumnSize+imageWidth/ro+marigin;
                                [to setTag:i];
                                
                                [to addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                
                                [self.scrollView addSubview:to];
                            }
                            [scrollView setContentSize:CGSizeMake(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width, leftColumnSize)];
                        }
                        else
                        {
                            posx=2*marigin+imageWidth+leftBar.frame.size.width;
                            
                            Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
                            UIImage*p=temp.downloadedMainImage;
                            if (p!=nil) {
                                float r=p.size.width/p.size.height;
                                
                                UIButton*t= [[UIButton alloc]initWithFrame:CGRectMake(posx, rightColumnSize, imageWidth, imageWidth/r)];
                                [t setTag:index];
                                [t setBackgroundImage:p forState:UIControlStateNormal];
                                [t addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                
                                rightColumnSize=rightColumnSize+imageWidth/r;
                                [self.scrollView addSubview:t];
                            }
                            UIImage*po=temp.downloadedMenuImage;
                            if (po!=nil) {
                                float ro=po.size.width/po.size.height;
                                
                                
                                UIButton*to= [[UIButton alloc]initWithFrame:CGRectMake(posx, rightColumnSize, imageWidth, imageWidth/ro)];
                                [to setBackgroundImage:po forState:UIControlStateNormal];
                                [to setTag:i];
                                rightColumnSize=rightColumnSize+imageWidth/ro+marigin;
                                [to addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                [self.scrollView addSubview:to];
                            }
                            
                            [scrollView setContentSize:CGSizeMake(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width, rightColumnSize)];
                        }
                    }
                    
                });
                
            });
        }
    }
    if(saveNewRestaurantJSON)
        [connectionManager updateDistrictJSON];
}


-(void) saveImageFormData:(NSDictionary*) args{
    if([args objectForKey:@"imageData"] != nil){
        UIImage *image =[[UIImage alloc]initWithData:[args objectForKey:@"imageData"]];
        [UIImageJPEGRepresentation(image, 1.0) writeToFile:[args objectForKey:@"fileName"] options:nil error:nil];
    }
    else
        NSLog(@"Empty file");
}

-(void)getLogoImage: (int) i{
    Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
    NSString *cachesPath = [[NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) lastObject] stringByAppendingPathComponent:@"logos"];
    NSString *imageName = [[[temp city] stringByAppendingFormat:@"___%@",[temp name]]
                           stringByAppendingPathExtension:@"jpg"];
    NSString *cacheFile = [cachesPath stringByAppendingPathComponent: imageName];
    
    if([connectionManager cachedRestaurants].count <= i
       || ![temp.logoImage isEqualToString: [[[connectionManager cachedRestaurants] objectAtIndex:i] objectForKey:@"logoImage"]]
       || ![[NSFileManager defaultManager] fileExistsAtPath:cacheFile] ){
        NSURL *url1 = [NSURL URLWithString:temp.logoImage];
        NSData *data1 = [NSData dataWithContentsOfURL:url1];
        temp.downloadedMainImage=[[UIImage alloc]initWithData:data1];
        NSLog(@"Downloaded logo image");
        NSDictionary * args = [NSDictionary dictionaryWithObjectsAndKeys:
                               data1, @"imageData",
                               cacheFile, @"fileName",
                               nil];
        
        [self performSelectorInBackground:@selector(saveImageFormData:) withObject:args];
        saveNewRestaurantJSON=YES;
    }
    else{
        NSLog(@"Cached logo image");
        temp.downloadedMainImage = [UIImage imageWithContentsOfFile:cacheFile];
    }
}



-(void)loadDistrictScrollView{
    
    counter=0;
    counter2=0;
    for (int i=0; i<[connectionManager.districts count]; i++) {
        District* d=[connectionManager.districts objectAtIndex:i];
        if ([d.districtId isEqual:self.districtId]) {
            cityLabel.text=d.name;
        }
    }
    
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
    
//    [loadingView setAlpha:0.0f];
    
    [UIView commitAnimations];
    
    //    NSLog(@"started");
    int marigin=10;
    int imageWidth=(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width-marigin*3)/2;
    leftColumnSize=70;
    rightColumnSize=70;
    
    if ([[self appdelegate]isRestaurantsScreenLoaded]) {
        //  NSLog(@"jest zaladowane")  ;
    }
    else
    {
        
        for(UIView *subview in [scrollView subviews]) {
            [subview removeFromSuperview];
        }
        
        
        
        for(int i=0;i<[connectionManager.restaurants count];i++)
        {
            
            Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
            if ([connectionManager.restaurants count]>0
                && i < [connectionManager.restaurants count]
                && !temp.menuImageDefault)
            {
                counter++;
                dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
                    
                    [self getLogoImage:i];
                    
                    NSString*blobEnding=temp.menuImage;
                    NSURL *url = [NSURL URLWithString:blobEnding];
                    NSData *data = [NSData dataWithContentsOfURL:url];
                    temp.downloadedMenuImage=[[UIImage alloc]initWithData:data];
                    //                    if ([connectionManager.restaurants count]>0) {
                    
                    //                    }
                    
                    dispatch_async( dispatch_get_main_queue(), ^{
                        
                        counter2++;
                        
                        if ([connectionManager.restaurants count]>0 && i < [connectionManager.restaurants count]) {
                        //    NSLog(@"--///%@",[[connectionManager.restaurants objectAtIndex:i]name]);
                            [self.orderOfDownloadedImages addObject:[connectionManager.restaurants
                                                                     objectAtIndex:i]];
                            
                            if (leftColumnSize<=rightColumnSize) {
                                posx=marigin+leftBar.frame.size.width;
                                Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
                                UIImage*p=temp.downloadedMainImage;
                                if (p!=nil) {
                                    float r=p.size.width/p.size.height;
                                    
                                    UIButton*t= [[UIButton alloc]initWithFrame:CGRectMake(posx, leftColumnSize, imageWidth, imageWidth/r)];
                                    [t setTag:i];
                                    [t setBackgroundImage:p forState:UIControlStateNormal];
                                    [t addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                    leftColumnSize=leftColumnSize+imageWidth/r;
                                    [self.scrollView addSubview:t];
                                }
                                
                                UIImage*po=temp.downloadedMenuImage;
                                if (po!=nil) {
                                    
                                    float ro=po.size.width/po.size.height;
                                    
                                    UIButton*to= [[UIButton alloc]initWithFrame:CGRectMake(posx, leftColumnSize, imageWidth, imageWidth/ro)];
                                    
                                    [to setBackgroundImage:po forState:UIControlStateNormal];
                                    leftColumnSize=leftColumnSize+imageWidth/ro+marigin;
                                    [to setTag:i];
                                    
                                    [to addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                    
                                    [self.scrollView addSubview:to];
                                }
                                [scrollView setContentSize:CGSizeMake(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width, leftColumnSize)];
                            }
                            else
                            {
                                posx=2*marigin+imageWidth+leftBar.frame.size.width;
                                
                                Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
                                UIImage*p=temp.downloadedMainImage;
                                if (p!=nil) {
                                    float r=p.size.width/p.size.height;
                                    
                                    UIButton*t= [[UIButton alloc]initWithFrame:CGRectMake(posx, rightColumnSize, imageWidth, imageWidth/r)];
                                    [t setTag:i];
                                    [t setBackgroundImage:p forState:UIControlStateNormal];
                                    [t addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                    
                                    rightColumnSize=rightColumnSize+imageWidth/r;
                                    [self.scrollView addSubview:t];
                                }
                                UIImage*po=temp.downloadedMenuImage;
                                if (po!=nil) {
                                    float ro=po.size.width/po.size.height;
                                    
                                    
                                    UIButton*to= [[UIButton alloc]initWithFrame:CGRectMake(posx, rightColumnSize, imageWidth, imageWidth/ro)];
                                    [to setBackgroundImage:po forState:UIControlStateNormal];
                                    [to setTag:i];
                                    rightColumnSize=rightColumnSize+imageWidth/ro+marigin;
                                    [to addTarget:self action:@selector(goToNextScreen:) forControlEvents:UIControlEventTouchUpInside];
                                    [self.scrollView addSubview:to];
                                }
                                
                                [scrollView setContentSize:CGSizeMake(screenWidth-leftBar.frame.size.width-rightBar.frame.size.width, rightColumnSize)];
                                
                               
                            }
                        }
                    
                        
                          
                    });
                    if(counter2+1==counter){
                        NSLog(@"!!!!!!!!!!!!!!!;kj;lkj;kj;k!!!!!!!");
                        [self performSelectorInBackground:@selector(loadNoContentMenus) withObject:nil];
                    }
                    
                    
                    NSLog(@"counter:  %d   and c2: %d",counter, counter2   );
                });
                
                            
            }
            
        }
        
    if (counter==0 && counter2==0)
    {
        [self performSelectorInBackground:@selector(loadNoContentMenus) withObject:nil];
    }
        [self appdelegate].isRestaurantsScreenLoaded=YES;
    }
   
}


-(void)loadNearbyScrollView{
    for (int i=0; i<[connectionManager.districts count]; i++) {
        District* d=[connectionManager.districts objectAtIndex:i];
        if ([d.districtId isEqual:self.districtId]) {
            cityLabel.text=d.name;
            break;
        }
    }
    //  [self prepareMenuViews];
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
//    [loadingView setAlpha:0.0f];
    [UIView commitAnimations];
    
    
    for(int i=0;i<[connectionManager.restaurants count];i++)
    {
        if(connectionManager.restaurants.count > 0 && i<[connectionManager.restaurants count]){
            dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
                
                Restaurant*temp= [connectionManager.restaurants objectAtIndex:i];
                
                //                NSString*blobEnding2=temp.logoImage;
                //                NSURL *url1 = [NSURL URLWithString:blobEnding2];
                //                NSData *data1 = [NSData dataWithContentsOfURL:url1];
                //                temp.downloadedMainImage=[[UIImage alloc]initWithData:data1];
                [self getLogoImage:i];
                
                NSString*blobEnding=temp.menuImage;
                NSURL *url = [NSURL URLWithString:blobEnding];
                NSData *data = [NSData dataWithContentsOfURL:url];
                temp.downloadedMenuImage=[[UIImage alloc]initWithData:data];
                
                dispatch_async( dispatch_get_main_queue(), ^{
                    if ([connectionManager.restaurants count]>0 && i<[connectionManager.restaurants count]) {
                        [self.orderOfDownloadedImages addObject:[connectionManager.restaurants
                                                                 objectAtIndex:i]];
                        
                        [[headersImg objectAtIndex:i]
                         setImage:[[connectionManager.restaurants objectAtIndex:i]downloadedMainImage]
                         forState:UIControlStateNormal];
                        [[headersImg objectAtIndex:i] setTag:i+2000];
                        
                        [[menusImg objectAtIndex:i]
                         setImage:[[connectionManager.restaurants objectAtIndex:i]downloadedMenuImage]
                         forState:UIControlStateNormal];
                        [[menusImg objectAtIndex:i] setTag:i+1000];
                    }
                });
            });
        }
    }
    Restaurant *rest=(Restaurant*)[connectionManager.restaurants objectAtIndex:0];
    
    if(rest.distance >=1000)
        cityLabel.text = [NSString stringWithFormat: @"%@ %.2f km",
                          NSLocalizedString(@"Distance", nil),
                          rest.distance];
    else
        cityLabel.text = [NSString stringWithFormat: @"%@ %.f m",
                          NSLocalizedString(@"Distance", nil),
                          rest.distance];
    
    if(saveNewRestaurantJSON)
        [connectionManager updateDistrictJSON];
    
    [self appdelegate].isRestaurantsScreenLoaded=YES;
}



-(void)goToNextScreen:(UIButton *)sender
{
    for (int w=0; w<[orderOfDownloadedImages count]; w++) {
        NSLog(@"--///%@",[[orderOfDownloadedImages objectAtIndex:w]name]);
    }
    [self animateViewChange];
    infoViewController.restaurants=[[NSMutableArray alloc]initWithArray:connectionManager.restaurants];

    NSLog(@"%d",sender.tag);
    infoViewController.index=sender.tag;
   
    [self.navigationController pushViewController:infoViewController animated:NO];
  
}


- (AppDelegate *) appdelegate {
    return (AppDelegate *)[[UIApplication sharedApplication] delegate];
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


-(BOOL)shouldAutorotate{
    UIInterfaceOrientation interfaceOrientation = [[UIDevice currentDevice] orientation];
    return interfaceOrientation==UIInterfaceOrientationLandscapeLeft || interfaceOrientation==UIInterfaceOrientationLandscapeRight;
}

- (NSUInteger)supportedInterfaceOrientations{
    if ([self isPad]) {
        return UIInterfaceOrientationMaskPortrait;
    }
    else
    return UIInterfaceOrientationMaskAll;
}

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)  interfaceOrientation duration:(NSTimeInterval)duration
{
    [self shouldAutorotateToInterfaceOrientation:[[UIDevice currentDevice] orientation]];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    NSLog(@"auto rotate");
    if(interfaceOrientation==UIInterfaceOrientationLandscapeLeft || interfaceOrientation==UIInterfaceOrientationLandscapeRight){
        if ([self isPad]) {
            ;
        }
        else
        {
        if(![[[self navigationController]topViewController] isEqual:restaurantsHorizontalView]){
            //if(![self appdelegate].isFindNearby)
                restaurantsHorizontalView.currentDistrictName = cityLabel.text;
            //else
            //    restaurantsHorizontalView.currentDistrictName = NSLocalizedString(@"FindNearby", nil);
            [self appdelegate].currentIndex = 0;
            restaurantsHorizontalView.currentRestaurantIndex= 0;
            restaurantsHorizontalView.restaurants=connectionManager.restaurants;
            //restaurantsHorizontalView.restaurants=self.orderOfDownloadedImages;
            [self animateViewChange];
            [[self navigationController] pushViewController: restaurantsHorizontalView animated:NO];
        }
        }
    }
    return YES;
}

- (void)viewDidUnload {
    [self setScrollView:nil];
    [self setLeftBar:nil];
    [self setRightBar:nil];
    [self setTopBar:nil];
    [self setTopBar:nil];
    [self setScrollViewBackground:nil];
    [self setScrollViewBackground:nil];
    [self setCityLabel:nil];
    [self setLoadingView:nil];
    [super viewDidUnload];
}


- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration
{
    [UIView setAnimationsEnabled:NO]; // disable animations temporarily
}

- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation
{
    [UIView setAnimationsEnabled:YES]; // rotation finished, re-enable them
}



- (IBAction)goBack:(id)sender {
    [self animateViewChange];
    [self.navigationController popViewControllerAnimated:NO];
}
- (IBAction)switchOrientation:(id)sender {

    singleScrollViewController=[self.storyboard instantiateViewControllerWithIdentifier:@"singleScrollView" ];
    if ([[self appdelegate]isFindNearby]) {
        singleScrollViewController.restaurants=[[NSMutableArray alloc]initWithArray:connectionManager.restaurants];

    }
    else
    singleScrollViewController.restaurants=[[NSMutableArray alloc]initWithArray:orderOfDownloadedImages];
    
       
    
        [self appdelegate].currentIndex = 0;   //test
        singleScrollViewController.cityName=self.cityLabel.text;
    
    [self animateViewChange];
    [self.navigationController pushViewController:singleScrollViewController animated:NO];
    
}

-(void)animateViewChange{
    CATransition* transition = [CATransition animation];
    transition.duration = 0.4;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    NSLog(@"%d",buttonIndex);
    if(alertView.tag == 0){
//        [loadingView setAlpha:0];
        [self animateViewChange];
        [self.navigationController popViewControllerAnimated:NO];
    }
    else if(alertView.tag == 1){
        [self.navigationController popViewControllerAnimated:NO];
    }
}
@end
