//
//  MRAID2.h
//  iBillboardClasses
//
//  Created by Pawel Ferens on 4/17/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol MRAID2 <NSObject>
-(void)expand;
-(void)addEventListener;
-(void)createCalendarEvent;
-(void)close;
-(void)getCurrentPosition;
-(void)getDefaultPosition;
-(void)getExpandProperties;
-(void)getMaxSize;
-(void)getPlacementType;
-(void)getResizeProperties;
-(void)getScreenSize;
-(void)getState;
-(void)getVersion;
-(void)isViewable;
-(void)open;
-(void)playVideo;
-(void)removeEventListener;
-(void)selfExpandProperties;
-(void)setResizeProperties;
-(void)storePictureWithString:(NSString*)string;
-(void)supports;
-(void)useCustomClose;
-(void)resize;

@end
