//
//  DistrictsController.h
//  MenuMenu
//
//  Created by Sławek Derwisz on 26.02.2013.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ConnectionManager.h"
#import "MainScrollViewController.h"
#import "AppDelegate.h"
#import <CoreLocation/CoreLocation.h>
#import "LocationManager.h"
#import "Reachability.h"
@interface DistrictsViewController : UIViewController
<UIPageViewControllerDelegate, UIScrollViewDelegate, UITableViewDelegate, UITableViewDataSource,CLLocationManagerDelegate>{
    IBOutlet UIImageView *topBar;
    IBOutlet UIScrollView *scrollView;
    IBOutlet UIPageControl *pageControl;
    IBOutlet UIButton *menuButton;
    IBOutlet UITableView *menu;
    BOOL pageControlUsed;
    int kNumberOfPages;
    ConnectionManager *connManager;
    
    NSMutableArray *items;
    MainScrollViewController *mainScrollView;
}
- (IBAction)goBack:(id)sender;
@property (nonatomic, retain) UIButton * currentDistrictButton;
@property (nonatomic, retain) UIScrollView *scrollView;
@property (strong, nonatomic) IBOutlet UIButton *back;
@property (nonatomic, retain) UIPageControl *pageControl;
@property (strong, nonatomic) IBOutlet UIImageView *loadingView;
@property (nonatomic,retain) UIActivityIndicatorView* spinner;
@property bool isInfoShowed;
-(IBAction)changePage;
@end
