//
//  MapViewController.h
//  MenuMenu
//
//  Created by Pawel Ferens on 3/1/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import <MapKit/MapKit.h>
#import "Restaurant.h"
#import "LocationManager.h"
#import <QuartzCore/QuartzCore.h>

@interface MapViewController : UIViewController<CLLocationManagerDelegate>

@property (strong, nonatomic) IBOutlet MKMapView * mapController;
@property (strong, nonatomic) IBOutlet UIWebView *webView;
@property (strong, nonatomic) IBOutlet UIImageView *topBar;
@property(nonatomic,retain)Restaurant* restaurant;

- (IBAction)goBack:(id)sender;
- (IBAction)showWay:(id)sender;
@property (strong, nonatomic) IBOutlet UILabel *distanceLabel;
@property(nonatomic,retain)NSString* distance;
@end
