//
//  ViewController.m
//  MenuMenu
//
//  Created by Pawel Ferens on 2/26/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize districtsView;

-(void)goToDistrictView{
    districtsView=[self.storyboard instantiateViewControllerWithIdentifier:@"districtsView" ];
    
    CATransition* transition = [CATransition animation];
    transition.duration = 0.6;
    transition.type = kCATransitionFade;
    transition.subtype = kCATransitionFromTop;
    
    [self.navigationController.view.layer
     addAnimation:transition forKey:kCATransition];
    
    [[self navigationController] pushViewController: districtsView animated:NO];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    
//    Reachability *networkReachability = [Reachability reachabilityForInternetConnection];
//    NetworkStatus networkStatus = [networkReachability currentReachabilityStatus];
//    if (networkStatus == NotReachable) {
//        NSLog(@"There IS NO internet connection");
//    } else {
//        
//        NSLog(@"There IS internet connection");
//        
//        
//    }        
//
//    
    
    
    NSString *notificationName = @"DistrictLoaded";
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(goToDistrictView)
     name:notificationName
     object:nil];
    
    [[ConnectionManager getInstance] getDistrictsFromCountry:nil];
    
   
    
   

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
