//
//  iBillboard.h
//  iBillboardClasses
//
//  Created by Pawel Ferens on 4/15/13.
//  Copyright (c) 2013 Pawel Ferens. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "TGJSBridge.h"
#import <QuartzCore/QuartzCore.h>
#import "MRAID2.h"
#import "ExpandProperties.h"
#import "ResizeProperties.h"
#import <QuartzCore/QuartzCore.h>
#import <EventKit/EventKit.h>

@interface AdView : UIWebView<UIWebViewDelegate,TGJSBridgeDelegate,UIApplicationDelegate,MRAID2>

@property (retain, nonatomic) TGJSBridge *jsBridge;

-(id) initWithView:(UIView*)actualView andPlacementType:(NSString*)placementType;
-(NSString *) getDeviceInfo;
-(void)setVersion;
@end
