
var currentPosition=new Object();
var defaultPosition=new Object();
var version;
var stateType;
var placementType;
var viewable;
var expandProperties;
var orientationProperties;
var resizeProperties;
var maxSize=new Object();
var screenSize =new Object();
var click_count = 0;


function addEventListener(){
    jsBridge.postNotification('addEventListener',{message:'hello oc:'+(++click_count)});
}

function createCalendarEvent(obj){
    
    var s = "";
    
    if (typeof obj == 'object') {
        
        if (obj.push) {
            
            var out = [];
            
            for (var p = 0; p < obj.length; p++) {
                
                out.push(obj[p]);
                
            }
            
            s =  '[' + out.join(',') + ']';
            
        } else {
            
            var out = [];
            
            for (var p in obj) {
                
                out.push('\"'+p+'\":'+'\"'+obj[p]+'\"');
                
            }
            
            s =  '{' + out.join(',') + '}';
            
        }
        
    } else {
        
        s  =  String(obj);
        
    }
    
    
    jsBridge.postNotification('createCalendarEvent',{message:s});
  
}

function close(){   //done
    jsBridge.postNotification('close',{message:'hello oc:'});
}

function expand(){ //done
    
    jsBridge.postNotification('expand',{message:'hello oc:'+(++click_count)});
}

function getCurrentPosition(){ //done

    alert(currentPosition.x + ' ' + currentPosition.y);
}

function getDefaultPosition(){  //done

    alert(defaultPosition.x + ' ' + defaultPosition.y);
}

function getExpandProperties(){     //done
    
    return expandProperties;
}

function getMaxSize(){ //done

    alert(maxSize.heigth);
}

function getPlacementType(){  //done

    alert(placementType);
}

function getResizeProperties(){     //done
    return resizeProperties;

}

function getScreenSize(){  //done
    alert (screenSize.heigth);
}

function getState(){  //done
  
    alert(stateType);
    return stateType;
    
}

function getVersion(){  //done
    
    alert(version);
    return version;
}

function isViewable(){      //done
    if((Number(currentPosition.x)+Number(currentPosition.width))>Number(screenSize.width)  || (Number(currentPosition.x))<0 || (Number(currentPosition.y)+Number(currentPosition.height)>screenSize.height) || currentPosition.y<0)
    {
        return false;
    }
    else return true;
}

function open(url){     //done
    jsBridge.postNotification('open',{message:url});
}

function playVideo(url){        //done
    jsBridge.postNotification('playVideo',{message:url});
}

function removeEventListener(){
    jsBridge.postNotification('removeEventListener',{message:'hello oc:'+(++click_count)});
}

function resize(){  //done
    jsBridge.postNotification('resize',{message:'hello oc:'+(++click_count)});
}

function setExpandProperties(obj){  //done
    
    var s = "";
    
    if (typeof obj == 'object') {
        
        if (obj.push) {
            
            var out = [];
            
            for (var p = 0; p < obj.length; p++) {
                
                out.push(obj[p]);
                
            }
            
            s =  '[' + out.join(',') + ']';
            
        } else {
            
            var out = [];
            
            for (var p in obj) {
                
                out.push('\"'+p+'\":'+'\"'+obj[p]+'\"');
                
            }
            
            s =  '{' + out.join(',') + '}';
            
        }
        
    } else {
        
        s  =  String(obj);
        
    }
    
    
    
    expandProperties=obj;
    jsBridge.postNotification('setExpandProperties',{message:obj});
  
}

function setResizeProperties(obj){      //done
    resizeProperties=obj;
    jsBridge.postNotification('setResizeProperties',{message:obj});
    
   
}

function storePicture(obj){
    jsBridge.postNotification('storePicture',{message:obj});
}

function supports(){
    jsBridge.postNotification('supports',{message:'hello oc:'+(++click_count)});
}

function useCustomClose(){
    jsBridge.postNotification('useCustomClose',{message:'hello oc:'+(++click_count)});
}

function error(){
    jsBridge.postNotification('error',{message:'hello oc:'+(++click_count)});
}

function sizeChange(){
    jsBridge.postNotification('sizeChange',{message:'hello oc:'+(++click_count)});
}

function stateChange(){
    jsBridge.postNotification('stateChange',{message:'hello oc:'+(++click_count)});
}

function viewableChange(){
    jsBridge.postNotification('viewableChange',{message:'hello oc:'+(++click_count)});
}


(function(context){
 
 
    function bridgeCall(src,callback) {
		iframe = document.createElement("iframe");
		iframe.style.display = "none";
		iframe.src = src;
		var cleanFn = function(state){
		   console.log(state) 
		    try {
		        iframe.parentNode.removeChild(iframe);
		    } catch (error) {}
		    if(callback) callback();
		};
        iframe.onload = cleanFn;
		document.documentElement.appendChild(iframe);

	}
 

    function JSBridge()
    {
        this.callbackDict = {};
        this.notificationIdCount = 0;
        this.notificationDict = {};
        
        var that = this;
        context.document.addEventListener('DOMContentLoaded',function(){
            bridgeCall('jsbridge://NotificationReady',that.trigger('jsBridgeReady',{}));
        },false);
    }

    JSBridge.prototype = {
        constructor: JSBridge,
        //send notification to WebView
        postNotification: function(name, userInfo){
 

            this.notificationIdCount++;
            
            this.notificationDict[this.notificationIdCount] = {name:name, userInfo:userInfo};

            bridgeCall('jsbridge://PostNotificationWithId-' + this.notificationIdCount);
        },
        //pop the notification in the cache
        popNotificationObject: function(notificationId){
            var result = JSON.stringify(this.notificationDict[notificationId]);
            delete this.notificationDict[notificationId];
            return result;
        },
        //trigger the js event
        trigger: function(name, userInfo) {
 
            if(this.callbackDict[name]){
                var callList = this.callbackDict[name];
                
                for(var i=0,len=callList.length;i<len;i++){
                    callList[i](userInfo);
                }
            }
        },
        //bind js event
        bind: function(name, callback){
            if(!this.callbackDict[name]){
                //create the array
                this.callbackDict[name] = [];
            }
            this.callbackDict[name].push(callback);
        },
        //unbind js event
        unbind: function(name, callback){
            if(arguments.length == 1){
                delete this.callbackDict[name];
            } else if(arguments.length > 1) {
                if(this.callbackDict[name]){
                    var callList = this.callbackDict[name];
                    
                    for(var i=0,len=callList.length;i<len;i++){
                        if(callList[i] == callback){
                            callList.splice(i,1);
                            break;
                        }
                    }
                }
                if(this.callbackDict[name].length == 0){
                    delete this.callbackDict[name];
                }
            }
            
        }
        
    };
     
    context.jsBridge = new JSBridge();
    
})(window);
function process()
{
    jsBridge.postNotification('oc',{message:'hello oc:'});
}

jsBridge.bind('setVersion', function(object){
              
              version=object.message;
             
              });

jsBridge.bind('setScreenWidth', function(object){
             
              screenSize.width=object.message;
          
              });
jsBridge.bind('setScreenHeight', function(object){
               screenSize.heigth=object.message;
            
              });
jsBridge.bind('setPlacementType', function(object){
              placementType=object.message;
              
              });
jsBridge.bind('setStateType', function(object){
              stateType=object.message;
              
              });
jsBridge.bind('setMaxSizeWidth', function(object){
              maxSize.width=object.message;
              
              });
jsBridge.bind('setMaxSizeHeigth', function(object){
              maxSize.heigth=object.message;
              
              });
jsBridge.bind('setCurrentPositionX', function(object){
              currentPosition.x=object.message;
              
              });
jsBridge.bind('setCurrentPositionY', function(object){
              currentPosition.y=object.message;
              
              });
jsBridge.bind('setCurrentPositionWidth', function(object){
              currentPosition.width=object.message;
              
              });
jsBridge.bind('setCurrentPositionHeigth', function(object){
              currentPosition.heigth=object.message;
              
              });

jsBridge.bind('setDefaultPositionX', function(object){
              defaultPosition.x=object.message;
              
              });
jsBridge.bind('setDefaultPositionY', function(object){
              defaultPosition.y=object.message;
              
              });
jsBridge.bind('setDefaultPositionWidth', function(object){
              defaultPosition.width=object.message;
              
              });
jsBridge.bind('setDefaultPositionHeigth', function(object){
              defaultPosition.heigth=object.message;
              
              });